CREATE DATABASE twitter;
CREATE USER dbuser WITH ENCRYPTED PASSWORD 'password';
GRANT ALL PRIVILEGES ON DATABASE twitter TO dbuser;



CREATE TABLE TWITTER_USER (
    USER_ID BIGINT,
    NAME VARCHAR(200),
    SCREEN_NAME VARCHAR(200)
);


CREATE TABLE TWEET (
    ID BIGINT,
    USER_ID BIGINT,
    CREATED_AT TIMESTAMP,
	TEXT VARCHAR(2000),
    LAT REAL,
    LON REAL,
    REPLY_COUNT INT,
    RETWEET_COUNT	INT,
    LANG VARCHAR(100)
);

CREATE TABLE HASHTAGS (
  TWEET_ID BIGINT,
  HASHTAG VARCHAR(100)  
);

CREATE TABLE MEDIA (
  TWEET_ID BIGINT,
  TYPE VARCHAR(100),
  URL VARCHAR(1000) ,
  URL_HASH VARCHAR(1000) 
);

CREATE TABLE CLUSTERS (
  URL_HASH VARCHAR(1000),
  CLUSTER INT
);


ALTER TABLE TWITTER_USER ADD PRIMARY KEY (USER_ID);

ALTER TABLE TWEET ADD PRIMARY KEY (ID);

ALTER TABLE HASHTAGS ADD PRIMARY KEY (TWEET_ID, HASHTAG);


ALTER TABLE TWEET ADD CONSTRAINT constraint_user FOREIGN KEY (USER_ID) REFERENCES TWITTER_USER (USER_ID);

ALTER TABLE MEDIA ADD CONSTRAINT contraint_media FOREIGN KEY (TWEET_ID) REFERENCES TWEET (ID);

ALTER TABLE HASHTAGS ADD CONSTRAINT contraint_hashtags FOREIGN KEY (TWEET_ID) REFERENCES TWEET (ID);




CREATE TABLE image_features (
image_hash VARCHAR(100),
is_person boolean,
is_bicycle boolean,
is_car boolean,
is_motorbike boolean,
is_aeroplane boolean,
is_bus boolean,
is_train boolean,
is_truck boolean,
is_boat boolean,
is_traffic_light boolean,
is_fire_hydrant boolean,
is_stop_sign boolean,
is_parking_meter boolean,
is_bench boolean,
is_bird boolean,
is_cat boolean,
is_dog boolean,
is_horse boolean,
is_sheep boolean,
is_cow boolean,
is_elephant boolean,
is_bear boolean,
is_zebra boolean,
is_giraffe boolean,
is_backpack boolean,
is_umbrella boolean,
is_handbag boolean,
is_tie boolean,
is_suitcase boolean,
is_frisbee boolean,
is_skis boolean,
is_snowboard boolean,
is_sports_ball boolean,
is_kite boolean,
is_baseball_bat boolean,
is_baseball_glove boolean,
is_skateboard boolean,
is_surfboard boolean,
is_tennis_racket boolean,
is_bottle boolean,
is_wine_glass boolean,
is_cup boolean,
is_fork boolean,
is_knife boolean,
is_spoon boolean,
is_bowl boolean,
is_banana boolean,
is_apple boolean,
is_sandwich boolean,
is_orange boolean,
is_broccoli boolean,
is_carrot boolean,
is_hot_dog boolean,
is_pizza boolean,
is_donut boolean,
is_cake boolean,
is_chair boolean,
is_sofa boolean,
is_pottedplant boolean,
is_bed boolean,
is_diningtable boolean,
is_toilet boolean,
is_tvmonitor boolean,
is_laptop boolean,
is_mouse boolean,
is_remote boolean,
is_keyboard boolean,
is_cell_phone boolean,
is_microwave boolean,
is_oven boolean,
is_toaster boolean,
is_sink boolean,
is_refrigerator boolean,
is_book boolean,
is_clock boolean,
is_vase boolean,
is_scissors boolean,
is_teddy_bear boolean,
is_hair_drier boolean,
is_toothbrush boolean);


CREATE TABLE downloaded_images (
    url_hash varchar(1000)
);