import keras
import os
import cv2
import numpy as np
from keras.applications import VGG19
from keras.applications.vgg19 import preprocess_input
from keras.layers import Dense, Dropout
from keras.models import Model
from keras import models
from keras import layers
from keras import optimizers
from keras.applications.resnet50 import ResNet50
from keras.preprocessing import image
from keras.applications.resnet50 import preprocess_input, decode_predictions
from sklearn.cluster import KMeans
from database import save
from database import query
import itertools
from image_processor import combine_images_in_cluster
import pickle
import psycopg2
import datetime


IMAGE_PATH = '/Users/Vamsi/Downloads/ti/'

print(os.getcwd())
def get_image_urls_from_db():

    conn = None
    try:
        conn = psycopg2.connect("dbname=twitter user=dbuser password=password") 
        cur = conn.cursor()
        cur.execute("SELECT url_hash FROM downloaded_images")
        rows = cur.fetchall()
        cur.close()
        return rows
    except (Exception, psycopg2.DatabaseError) as error:
        print(error)
    finally:
        if conn is not None:
            conn.close()


def cluster_images():
    output = {}
    my_new_model_1 = models.Sequential()
    my_new_model_1.add(ResNet50(include_top=False, pooling='avg', weights='imagenet'))
    my_new_model_1.layers[0].trainable = False

    resnet_feature_list = []
    img_list=get_image_urls_from_db()
    print("Len is " + str(len(img_list)))
    for idx, img in enumerate(img_list):
        if(idx < 50):
            full_image_path= IMAGE_PATH + "res_" + img[0] + ".jpg"
            input_img=cv2.imread(full_image_path)
            output[img] = input_img
        else:
            break
        # img = preprocess_input(np.expand_dims(input_img, axis=0))
        # resnet_feature = my_new_model_1.predict(img)
        # resnet_feature_np = np.array(resnet_feature)
        # resnet_feature_list.append(resnet_feature_np.flatten())
    #array1 = np.array(resnet_feature_list)
    pickle.dump(output, open("/Users/Vamsi/Downloads/tiny-learning.pkl", "wb"))

    
    # kmeans = KMeans(n_clusters=21, random_state=0).fit(array1)
    # labels = kmeans.labels_

    # clusters = []
    # cluster_list = []
    # for i, lab in enumerate(labels):
    #     clusters.append((img_list[i].replace('res_', '').replace('.jpg', ''), int(lab) + 1))
    #     cluster_list.append((int(lab) + 1, IMAGE_PATH + img_list[i]))
    # save('clusters', clusters)
    # cluster_dict = {}

    # for cl in cluster_list:
    #     if cl[0] in cluster_dict:
    #         cluster_dict[cl[0]].append(cl[1])
    #     else:
    #         cluster_dict[cl[0]] = [cl[1]]

    # for key in cluster_dict:
    #     print("Combining images for cluster - " + str(key))
    #     combine_images_in_cluster(key, cluster_dict[key])


cluster_images()