import numpy as np
import time
import cv2
import os
import pickle
import datetime
import sys


YOLO_LOCATION = "/tmp/"
CONFIDENCE = 0.5
THRESHOLD = 0.3
labelsPath = os.path.sep.join([YOLO_LOCATION, "coco.names"])
LABELS = open(labelsPath).read().strip().split("\n")
weightsPath = os.path.sep.join([YOLO_LOCATION, "yolov3.weights"])
configPath = os.path.sep.join([YOLO_LOCATION, "yolov3.cfg"])
net = cv2.dnn.readNetFromDarknet(configPath, weightsPath)
ln = net.getLayerNames()
ln = [ln[i[0] - 1] for i in net.getUnconnectedOutLayers()]

INDEX = sys.argv[1]

print(INDEX)

dbfile = open('/tmp/input-' + str(INDEX) + '.pkl', 'rb')      
print("Started Loading File " + str(datetime.datetime.now()))
db = pickle.load(dbfile) 
print("Ended Loading File " + str(datetime.datetime.now()))


print("Started Obj Detection " + str(datetime.datetime.now()))


list_tups = []
final_output = {}
for idx, key in enumerate(db): 
    if(True):
        print("Index " + str(idx))
        net.setInput(db[key])
        start = time.time()
        layerOutputs = net.forward(ln)
        end = time.time()
        confidences = []
        classIDs = []

        for output in layerOutputs:
            for detection in output:
                scores = detection[5:]
                classID = np.argmax(scores)
                confidence = scores[classID]
                if confidence > CONFIDENCE:
                    confidences.append(float(confidence))
                    classIDs.append(classID)
        objects = [i in classIDs for i in range(len(LABELS))]
        final_output[key] = objects

print("Ended Obj Detection " + str(datetime.datetime.now()))


OUTPUT_FILE = "/tmp/object_op" + str(INDEX) + ".pkl"
pickle.dump(output, open(OUTPUT_FILE, "wb"))

dbfile.close()