import boto3
import io
import cv2
import numpy as np
import os
import pickle

from pyspark.sql import SparkSession
from pyspark.sql.types import StringType


from keras.applications import VGG19
from keras.applications.vgg19 import preprocess_input
from keras.layers import Dense, Dropout
from keras.models import Model
from keras import models
from keras import layers
from keras import optimizers
from keras.applications.resnet50 import ResNet50
from keras.preprocessing import image
from keras.applications.resnet50 import preprocess_input, decode_predictions

import datetime

AWS_KEY_ID='AKIAYQWOE66CVTICVL4Z'
AWS_SECRET='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'
AWS_S3_BUCKET = 'dse-cohort5-group6'
my_new_model_1 = models.Sequential()
my_new_model_1.add(ResNet50(include_top=False, pooling='avg', weights='imagenet'))
my_new_model_1.layers[0].trainable = False



def process_image(key):
    #IMAGE_NAME = bucket_item.replace('images/','')
    #file_name = bucket_item.replace('images/','').replace('res_','').replace('.jpg','')
    #print("filename is " + file_name)
    #FILE_PATH = '/tmp/' + IMAGE_NAME
    #bucket.download_file(bucket_item, FILE_PATH)
    #input_img=cv2.imread(FILE_PATH)
    img = preprocess_input(np.expand_dims(key[1], axis=0))
    resnet_feature = my_new_model_1.predict(img)
    resnet_feature_np = np.array(resnet_feature)
    flattened_array = resnet_feature_np.flatten()
    return flattened_array

MAX_MEMORY = "10g"

print("Started Spark job " + str(datetime.datetime.now()))

spark = SparkSession \
        .builder \
        .appName("Twitter Image Analysis") \
        .config("spark.executor.memory", "10g") \
        .config("spark.driver.memory", "20g") \
        .getOrCreate()
sc = spark.sparkContext
print("Spark Initialized!!")
#db_bc = spark.sparkContext.broadcast(db)
print("Dict Broadcasted to all parititions")


# s3_client = boto3.client('s3', aws_access_key_id=AWS_KEY_ID,aws_secret_access_key=AWS_SECRET)
# s3_resource = boto3.resource('s3',aws_access_key_id=AWS_KEY_ID,aws_secret_access_key=AWS_SECRET)

# bucket = s3_resource.Bucket(AWS_S3_BUCKET)
# with open('/tmp/mini-learning.pkl', 'wb') as f:
#     s3_client.download_fileobj(AWS_S3_BUCKET, 'steps/step-1.pkl', f)



dbfile = open('/tmp/mini-learning.pkl', 'rb')      
print("Started Loading File " + str(datetime.datetime.now()))
db = pickle.load(dbfile) 
print("Ended Loading File " + str(datetime.datetime.now()))

list_tups = []

for idx, key in enumerate(db): 
    if(idx >= 3000 and idx < 6000):
        list_tups.append((key, db[key]))
dbfile.close() 

# print("list_tups size : " + str(len(list_tups)))
# #files_df = spark.createDataFrame(list(db.keys())[0:10], StringType())

rdd = sc.parallelize(list_tups)
print("RDD created")
output = rdd \
            .map(lambda row: (row[0], process_image(row))) \
            .collect()

print("Ended Spark job " + str(datetime.datetime.now()))


# print(rdd.count())

OUTPUT_FILE = "/tmp/output.pkl"
pickle.dump(output, open(OUTPUT_FILE, "wb"))
#bucket.upload_file(OUTPUT_FILE, 'output/output.pkl')


# s3 = boto3.resource('s3',aws_access_key_id=AWS_KEY_ID,aws_secret_access_key=AWS_SECRET)
# bucket = s3.Bucket('dse-cohort5-group6')
# files = list(bucket.objects.filter(Prefix='images/res'))
# file_list = [f.key for f in files]






# output = {}
# for f in files:
#     IMAGE_NAME = f.key.replace('images/','')
#     FILE_PATH = '/tmp/' + IMAGE_NAME
#     bucket.download_file(f.key, FILE_PATH)
#     input_img=cv2.imread(FILE_PATH)
#     img = preprocess_input(np.expand_dims(input_img, axis=0))
#     resnet_feature = my_new_model_1.predict(img)
#     resnet_feature_np = np.array(resnet_feature)
#     flattened_array = resnet_feature_np.flatten()
#     output[IMAGE_NAME] = flattened_array
#     os.remove(FILE_PATH)

# OUTPUT_FILE = "/tmp/output.pkl"
# pickle.dump(output, open(OUTPUT_FILE, "wb"))
# bucket.upload_file(OUTPUT_FILE, 'output/output.pkl')